#ifndef _LOFT_API_H
#define _LOFT_API_H

#define OK       0
#define ETIMEOUT 2
#define ENEXT    3
#define EBADLINK 4

scheduler_t implicit_scheduler     (void);
scheduler_t current_scheduler      (void);

scheduler_t scheduler_create       (void);
scheduler_t scheduler_nd_create    (void);
void        scheduler_start        (scheduler_t); 
int         scheduler_react        (scheduler_t,int k);
void        scheduler_instant      (scheduler_t);

event_t     event_create           (void);
event_t     event_create_in        (scheduler_t);

void        generate               (event_t);
void        generate_value         (event_t,void*);

void        stop                   (thread_t);
void        suspend                (thread_t);
void        resume                 (thread_t);

int         return_code            (void);
thread_t    self                   (void);

void        thread_deallocate      (thread_t);
void        event_deallocate       (event_t);
void        scheduler_deallocate   (scheduler_t);

void        loft_initialize        (void);

void*       local_data             (thread_t);

#define local(k) (_local_vars->k)

#endif /* _LOFT_API_H */
