#include <stdio.h>
#include "itemlist.h"
#include "local.h"

char *mysprintf(char *format, ...);

/****************************************************/
static char *init (char *param)
{
   return mysprintf ("_locals->%s = %s;",param,param);
}

char *initialize (item_list_t list)
{
   char *res;
   item_cell_t cell;
   local_data_t param;
   
   if (_length_of_item_list (list) == 0) return "";
   
   cell = _first_cell (list);
   param = (local_data_t)_content_of_cell (cell);   
   res = init (param->name);
   
   if (_length_of_item_list (list) == 1) return res;

   while ((cell = _next_cell (cell)) != NULL) {
      param = (local_data_t)_content_of_cell (cell); 
      res = mysprintf ("%s\n   %s",res,init (param->name));
   }
   return mysprintf ("%s\n",res);
}

/****************************************************/
char *declarations (item_list_t list)
{
   char *res;
   item_cell_t cell;
   local_data_t param;

   if (_length_of_item_list (list) == 0) return "";

   cell = _first_cell (list);   
   param = (local_data_t)_content_of_cell (cell);
   
   res = mysprintf ("%s %s",param->type,param->name);
   
   if (_length_of_item_list (list) == 1) return res;

   while ((cell = _next_cell (cell)) != NULL) {
      param = (local_data_t)_content_of_cell (cell);
      res = mysprintf ("%s,%s %s",res,param->type,param->name);
   }
   return res;
}

/****************************************************/
char *param_names (item_list_t list)
{
   char *res;
   item_cell_t cell;
   local_data_t param;

   if (_length_of_item_list (list) == 0) return "";

   cell = _first_cell (list);   
   param = (local_data_t)_content_of_cell (cell);
   
   res = mysprintf (",%s",param->name);
   
   if (_length_of_item_list (list) == 1) return res;

   while ((cell = _next_cell (cell)) != NULL) {
      param = (local_data_t)_content_of_cell (cell);
      res = mysprintf ("%s,%s",res,param->name);
   }
   return res;
}

/****************************************************/
