#include "loft_ft.h"

/******************************************/
ft_event_t event_create_in (ft_scheduler_t sched)
{
   return ft_event_create (sched);
}

ft_event_t event_create (void)
{
   return event_create_in (implicit_scheduler ());
}

void event_deallocate (ft_event_t event)
{
   myfree (event);
}

/******************************************/
void generate (ft_event_t event)
{
   ft_scheduler_t sched = _get_event_scheduler (event);
   if (current_scheduler () != sched) {
      ft_scheduler_broadcast (event);
      return;
   }
   ft_thread_generate (event);
}

void generate_value (ft_event_t event,void *val)
{
   ft_scheduler_t sched = _get_event_scheduler (event);
   if (current_scheduler () != sched) {
      ft_scheduler_broadcast_value (event,val);
      return;
   }
   ft_thread_generate_value (event,val);
}

/******************************************/
void stop (ft_thread_t th)
{
   ft_scheduler_stop (th);
}

void resume (ft_thread_t th)
{
   ft_scheduler_resume (th);
}

void suspend (ft_thread_t th)
{
   ft_scheduler_suspend (th);
}

void thread_deallocate (ft_thread_t thread)
{
   /* nothing */ 
}

/******************************************/
ft_scheduler_t scheduler_create (void)
{
   return ft_scheduler_create ();
}

ft_scheduler_t scheduler_nd_create (void)
{
   return ft_scheduler_nd_create ();
}

ft_scheduler_t current_scheduler (void)
{
   return ft_thread_scheduler ();
}

void scheduler_start (ft_scheduler_t sched)
{
   ft_scheduler_start (sched);
}

int scheduler_react (ft_scheduler_t sched,int k)
{
   return ft_scheduler_react (sched,k);
}

/******************************************/
ft_thread_t self (void) {
   return ft_thread_self ();
}

int return_code (void) {
   return _get_thread_return_code (ft_thread_self ());
}

/******************************************/
void* local_data (ft_thread_t thread)
{
   return _get_thread_args (thread);
}

/******************************************/
