#include <string.h>
#include "loft_ft.h"
#include "itemlist.h"
#include "local.h"

/****************************************************/
extern int native;
extern char *ModuleName;
extern int run_exists;
void reset_state_num (void);
char *constructor (item_list_t paramlist);
char *mysprintf(char *format, ...);

/****************************************************/
static char * native_shape = "\
void %s_fun (void *_args)\n{\n\
ft_thread_t _self = ft_thread_self ();\n\
%s_data_t _local_vars = (%s_data_t)_args;\n\
%s\n\
}";

static char * automaton_shape = "\
DEFINE_AUTOMATON(%s_fun)\n{\n\
%s_data_t _local_vars = (%s_data_t)_get_thread_args  (_self);\n\
BEGIN_AUTOMATON\n\
%s\n\
END_AUTOMATON\n\
}";

static char *finalize_shape = "\
void %s_finalize (void *_args)\n\
{\n\
   %s_data_t _local_vars = _args;\n\
   %s\n\
   %s\n\
}";

/****************************************************/
static char *finalize (char *atom)
{
   char *stop_run = "if (local(_run) != NULL) ft_scheduler_stop (local(_run));";
   return mysprintf (finalize_shape,
      ModuleName,
      ModuleName,
      (run_exists ? stop_run : ""),
      (atom ? atom : ""));
}

/****************************************************/
char *Module (item_list_t params,char *fin,item_list_t locals,char *stat)
{
   char *res, *fun;
   char *builder = constructor (params);

   if (native)
      fun = mysprintf (native_shape,ModuleName,ModuleName,ModuleName,stat);
   else
      fun = mysprintf (automaton_shape,ModuleName,ModuleName,ModuleName,stat);

   concat_local_data (params);
   concat_local_data (locals);
   
   if (run_exists) add_local_data ("ft_thread_t","_run");

   res = mysprintf ("%s\n%s\n%s\n%s",
		    local_data_structure (),
		    finalize (fin),
		    fun,
		    builder);

   reset_state_num ();
   run_exists = 0;
   return res;
}

char *ModuleName;
void set_module_name (char *name)
{
   if (0==strcmp(name,"main")) {
      ModuleName = "_main";
   } else {
      ModuleName = name;
   }
   reset_local_data_list ();
}

/****************************************************/
static char *extern_shape = "\
%sft_thread_t %s_create_in ();\n\
ft_thread_t %s_create ();\n";

char *ExternModule(item_list_t list)
{
   char *res = "";
   item_cell_t cell;
   if (_length_of_item_list (list) == 0) return res;
   
   cell = _first_cell (list);

   while (cell != NULL) {
      char *name = _content_of_cell (cell);
      res = mysprintf (extern_shape,res,name,name);
      cell = _next_cell (cell);
   }
   return res;   
}
