#include "itemlist.h"
#include "atom.h"
#include "loft_sem.h"

char* mysprintf(char *format, ...); 

/***************************************************/
static item_list_t atom_list;
static int        atom_num;

void initialize_atom_list (void)
{
  atom_num = 0;
  atom_list = _make_item_list ();
}

void reset_atom_list (void)
{
  atom_num = 0;
  _reset_item_list (atom_list);
}


/***************************************************/
static char *atom_shape = "      case %d: {%s} return NULL;";

int add_atom (char *atom)
{
   int res = atom_num;
   _append_item_list (atom_list,mysprintf (atom_shape,res,atom));
   atom_num++;
   return res;
}

/***************************************************/
static char *wrapper_shape = "      case %d: {void *res = (void*)(%s); return res;}";

int add_wrapper (char *wrapper)
{
   int res = atom_num;
   _append_item_list (atom_list,mysprintf (wrapper_shape,res,wrapper));
   atom_num++;
   return res;
}

/***************************************************/
static char *selector_shape =
"\
static void *%s_selector (int _n,%s_data_t _local_vars)\n\
{\n\
    switch (_n) {\
	%s\n\
    }\n\
    return NULL;\n\
}";


char *create_atom_selector (char *name)
{
   char *res, *body = "";
   int i;
   item_cell_t cell;
   int len = _length_of_item_list (atom_list);

   if (len == 0) return "";

   cell = _first_cell (atom_list);

   for (i=0;i<len;i++) {
      body = mysprintf ("%s\n%s",body,_content_of_cell (cell));
      cell = _next_cell (cell);
   }

   res = mysprintf (selector_shape,name,name,body);

   reset_atom_list ();
   return res;
}
