#include <string.h>
#include "itemlist.h"

extern char *ModuleName;

char *initialize   (item_list_t list);
char *declarations (item_list_t list);
char *param_names  (item_list_t list);
char *mysprintf    (char *format, ...);

/****************************************************/
static char *const_shape = "\
thread_t %s_create_in (scheduler_t _sched%s)\n\
{\n\
   thread_t _thread;\n\
   %s_data_t _locals = mymalloc (sizeof (struct %s_data_t));\n\
   %s\n\
   _thread = make_thread (_sched,%s (_locals),%s_finalize,_locals);\n\
   add_to_link (_sched,_thread);\n\
   return _thread;\n\
}\n\
thread_t %s_create (%s)\n\
{\n\
    return %s_create_in (implicit_scheduler ()%s);\n\
}";

char *constructor (item_list_t paramlist)
{
   char *params = declarations(paramlist);
   char *cparams =
        (0 == strcmp ("",params)) ? params
                                  : mysprintf (",%s",params);

   return mysprintf (const_shape,
      ModuleName,cparams,
      ModuleName,ModuleName,
      initialize(paramlist),
      ModuleName,ModuleName,
      ModuleName,((0 == strcmp ("",params)) ? "void" : params),
      ModuleName,param_names (paramlist)
   );
}
