#include "itemlist.h"
#include "expression.h"
#include "evaluate.h"
#include "broadcast.h"
#include "thread_sem.h"
#include "scheduler_sem.h"

scheduler_t current_scheduler (void);
thread_t self (void);

/***************************************************/
evaluate_t dispach_evaluate[] =
{
      wrapper_evaluate        ,
      constant_evaluate       ,
      thread_create_evaluate  ,
};

void *evaluate (expression_t exp)
{
   return dispach_evaluate [(int)exp->type] (exp);
}

/***************************************************/
void *wrapper_evaluate (expression_t exp)
{
   wrapper_t w = (wrapper_t)exp;
   return w->selector (w->n,self ()->locals);
}

/***************************************************/
void *constant_evaluate (expression_t exp)
{
   return ((constant_t)exp)->value;
}

/***************************************************/
void *thread_create_evaluate (expression_t exp)
{
   thread_create_t c = (thread_create_t)exp;
   add_to_link (current_scheduler (),c->thread);
   return c->thread;
}

